/* flag.h */

#define C_B 0
#define C_F 16
#define C_E 512

#define B_O  8
#define B_W  4
#define B_S  2
#define B_N  1 

#define B_NO  (B_N+B_O)
#define B_SO  (B_S+B_O)
#define B_SW  (B_S+B_W)
#define B_NW  (B_N+B_W)

#define BF (C_F+B_O+B_W+B_S+B_N)
#define BOUNDARY_FLAGS (FLAG[i][j] & BF)

#define C_L 512
#define C_O 256
#define C_W 128
#define C_S 64
#define C_N 32

#define C_NO   (C_N+C_O)
#define C_NW   (C_N+C_W)
#define C_SO   (C_S+C_O)
#define C_SW   (C_S+C_W)
#define C_NS   (C_N+C_S)
#define C_WO   (C_W+C_O)
#define C_NSWO (C_N+C_S+C_W+C_O)
#define C_NSW  (C_N+C_S+C_W)
#define C_NSO  (C_N+C_S+C_O)
#define C_NWO  (C_N+C_W+C_O)
#define C_SWO  (C_S+C_W+C_O)

#define SF (C_L+C_O+C_W+C_S+C_N)
#define SURFACE_FLAGS (FLAG[i][j] & SF)

#define HINDER(c) (!((c)&C_F))
#define RAND(c)   (HINDER(c)&&(((c)&B_O)||((c)&B_W)||((c)&B_S)||((c)&B_N)))
#define KANTE(c)  (((c)==B_O)||((c)==B_W)||((c)==B_S)||((c)==B_N))
#define ECK(c)    (((c)==B_NO)||((c)==B_SO)||((c)==B_SW)||((c)==B_NW))
#define VERBOT(c) (RAND(c)&&!ECK(c)&&!KANTE(c))

#define LEER(c)   ((c)&C_L)
#define OBERFL(c) (!LEER(c)&&(((c)&C_O)||((c)&C_W)||((c)&C_N)||((c)&C_S)))
/*#define OBERFL(c) (!LEER(c)&&(((c)&C_O)||((c)&C_W)||((c)&C_N)||((c)&C_S))&&!RAND(c)&&(i!=1)&&(i!=imax)&&(j!=1)&&(j!=jmax))*/
/*#define OBERFL(c) (((c)>=C_N)&&((c)<C_E)&&!RAND(c)&&(i!=1)&&(i!=imax)&&(j!=1)&&(j!=jmax))*/
#define INNER(c)  (!LEER(c)&&!OBERFL(c))

#define FLUID(c)  (!HINDER(c) && INNER(c))
#define FLUIDX(c) (!HINDER(c) && !LEER(c))

                  
