/* init.h */

#ifndef INIT_H
#define INIT_H

#ifndef REAL
#define REAL double
#endif

int READ_PARAMETER
(
    char *Inputfile,
    REAL *xlength, REAL *ylength,
    int *imax, int *jmax,
    REAL *delx, REAL *dely,
    REAL *delt, REAL *t_end, 
    REAL *tau, int *itermax, 
    REAL *eps, REAL *omg, REAL *alpha, REAL *Re,
    REAL *GX, REAL *GY, REAL *UI, REAL *VI, REAL *PI,
    REAL *del_vec,
    char *problem, int *wl, int *wr, int *wt, int *wb, 
    char *visualisierung, 
    int *N, REAL *x1, REAL *y1, REAL *x2, REAL *y2, 
    REAL *delt_trace, REAL *delt_inject, REAL *delt_streak,
    int *ppc
);

REAL **RMATRIX( int nrl, int nrh, int ncl, int nch );

void FREE_MATRIX( REAL **m, int nrl, int nrh, int ncl, int nch );

void INIT_UVP
( 
    REAL **U, REAL **V, REAL **P, 
    int imax, int jmax, 
    REAL UI, REAL VI, REAL PI, 
    char *problem
);

int **IMATRIX( int nrl, int nrh, int ncl, int nch );

void INIT_FLAG( char *problem, int **FLAG, int imax, int jmax ); 

#endif
