/* uvp.h */

#ifndef UVP_H
#define UVP_H

#ifndef REAL
#define REAL double
#endif

void COMP_FG
( 
    REAL **U, REAL **V,
    REAL **F, REAL **G, 
    int imax, int jmax,
    REAL delt, REAL delx, REAL dely, 
    REAL GX, REAL GY,
    REAL alpha, REAL Re, 
    int **FLAG
);

void COMP_RHS
(
    REAL **F, REAL **G,
    REAL **RHS, 
    int imax, int jmax, 
    REAL delt, REAL delx, REAL dely
);

int POISSON
(
    REAL **P, REAL **RHS,
    REAL **U, REAL **V,
    int imax, int jmax, 
    REAL delx, REAL dely,
    REAL eps, int itermax,
    REAL omg, REAL *res, 
    int **FLAG
);


void ADAP_UV
(
    REAL **U, REAL **V,
    REAL **F, REAL **G,
    REAL **P,
    int imax, int jmax, 
    REAL delt, REAL delx, REAL dely, 
    int **FLAG
);

#endif
