/* visual.h */

#ifndef VISUAL_H
#define VISUAL_H

#ifndef REAL
#define REAL double
#endif

#define AUSGABE COMP_PSI_ZETA( U, V, PSI, ZETA, FLAG, imax, jmax, delx, dely );\
    OUTPUTVEC( U, V, P, xlength, ylength, imax, jmax, FLAG, PSI, ZETA )
void OUTPUTVEC
(
    REAL **U, REAL **V, REAL **P, 
    REAL xlength, REAL ylength, 
    int imax, int jmax, 
    int **FLAG, 
    REAL **PSI, REAL **ZETA
);

struct particle
{
    REAL x, y;
    struct particle *next;
};

struct particleline
{
    int length;
    struct particle *Particles;
};

extern struct particleline *Particlelines;

struct particleline *SET_PARTICLES
(
    int N,
    REAL x1, REAL y1, REAL x2, REAL y2
);

void ADVANCE_PARTICLES
(
    int imax, int jmax, 
    REAL delx, REAL dely, REAL delt,
    REAL **U, REAL **V,
    int N, struct particleline *Particlelines,
    int **FLAG
);

void INJECT_PARTICLES
(
    int N,
    struct particleline *Particlelines
);

void WRITE_PARTICLES
(
    char *outputfile,
    int N,
    struct particleline *Particlelines
);

void PARTICLE_TRACING
(
    char *outputfile,
    REAL delt_trace,
    REAL t, int imax, int jmax, 
    REAL delx, REAL dely, REAL delt,
    REAL **U, REAL **V,
    int N,
    struct particleline *Particlelines, 
    REAL xlength, REAL ylength, 
    int **FLAG
);

void STREAKLINES
(
    char *outputfile,
    REAL delt_inject,
    REAL delt_streak,
    REAL t, int imax, int jmax, 
    REAL delx, REAL dely, REAL delt,
    REAL **U, REAL **V,
    int N,
    struct particleline *Particlelines, 
    REAL xlength, REAL ylength, 
    int **FLAG
);

void COMP_PSI_ZETA
(
    REAL **U, REAL **V, 
    REAL **PSI, REAL **ZETA, 
    int **FLAG,
    int imax, int jmax, 
    REAL delx, REAL dely
);

#endif
