/********************************************************************\
*                                                                    *
*  Projekt:   The Floatator                                          *
*  =============================================                     *
*                                                                    *
*  File:      ctrl_globals.c                                         *
*                                                                    *
*  Contents:  Global variables                                       *
*                                                                    *
*  Comment:                                                          *
*                                                                    *
*  History:                                                          *
*                                                                    *
*  Version  Author    Date    Comment                                *
*  ------- -------- -------- -------------------------------         *
*  0.0      Gordon  02.08.95 First steps                             *
*                                                                    *
*                                                                    *
0********1*********2*********3*********4*********5*********6*********7*********8
123456789012345678901234567890123456789012345678901234567890123456789012345678*/

/********************************************************************\
*                                                                    *
*                              Includes                              *
*                                                                    *
\********************************************************************/

#include "ctrl.h"
#include "view.h"

/********************************************************************\
*                                                                    *
*                              Variablen                             *
*                                                                    *
\********************************************************************/

char filename[FILENAME_MAX];

Arg          args[NUM_ARGS];
XmString     xms;
char         buffer[256];

Display      *display;
XtAppContext context;

struct WidgetIDs widget;

int floatator_socket;
char *socket_name;

struct CtrlParms ctrl = 
{
    FALSE, 
    0.0, 0.0, 0.0, 0.0, 
    3, 3, 
    0.0, 0.0, 0.0, 
    EM_SEL, 
    0, 
    PM_TRACING
};
struct ViewParms view = 
{
    0.0, 1.0, 0.0, 1.0, 
    1.0, 
    DM_FLUID, 
    FALSE, 
    5.0, 
    TRUE, 
    FALSE
};

struct DataPackage model = 
{
    1, 0, 1, 0,
    0.0, 0.0, 0.0, 0.0,
    {
        0, 0,
	0.0, 0.0,
	0.0, 0.0,
	0.0, 0.0,
	0,
	0.0, 0.0, 0.0,
	0.0, 0.0, 0.0,
	{
	    { BC_EIN, 0, 0.0, 0.0 },
	    { BC_EIN, 0, 0.0, 0.0 },
	    { BC_EIN, 0, 0.0, 0.0 },
	    { BC_EIN, 0, 0.0, 0.0 }
	},
	0.0, 0.0
    },
    NULL, NULL, NULL, NULL,
    NULL, NULL, NULL,
    NULL, NULL,
    { 
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL }
    },
    {
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL },
        { NULL, NULL }
    }, 0,
    "",
    0.0, 0.0, CS_NONE, 50.0, 0.0, 0    
};

char *calculation_state_strings[CS_NUMSTATES] = 
{
    "-----", 
    " mark", 
    "bcond", 
    " SOR ", 
    "fluid",  
    " part",
};

char *calculation_state_colors[CS_NUMSTATES] =
{
    "white", 
    "red", 
    "yellow", 
    "green", 
    "cyan", 
    "lightblue" 
};

char *residuum_colors[2] =
{
    "white",	/* The color of the residuum below eps */
    "red"       /* The color of the residuum above eps */
};

Cursor allocated_cursor = None;

struct CursorPixmaps cursor_pixmap;
