/* view.c */

#include "view.h"
#include "ctrl.h"

struct ViewColors color;
GC gc;
struct ParticlePixmaps pixmaps;

static unsigned long black, white;

void view_init()
{
}

void view_cleanup()
{}

void update_view()
{
    static int initialized = FALSE;
    XWindowAttributes attribs;
    REAL x, y;
    float sx, sy;
    float sx1, sy1, sx2, sy2;
    unsigned int width, height;
    int i, j;
    struct Particle *p;
    
    if( ! initialized )
    {
	XGCValues gc_values;
	int success;
	XrmValue from, to;
	
	XtSetArg( args[0], XmNforeground, &white );
	XtSetArg( args[1], XmNbackground, &black );
	XtGetValues( widget.Main.view, args, 2 );
	gc = XCreateGC
	(
	    display, 
	    XtWindow( widget.Main.view ), 
	    0, 
	    &gc_values
	);

	initialized = TRUE;
    }
    XClearWindow
    ( 
	display, 
	XtWindow( widget.Main.view ) 
    );
    XGetWindowAttributes
    ( 
	display, 
	XtWindow( widget.Main.view ), 
	&attribs 
    );
    switch( view.background )
    {
      case DM_U:
      Case DM_FLUID:
	for( i = 0; i < FLUID_FLAVORS; i++ )
	{
	    XSetForeground( display, gc, color.fluid[i] );
	    p = model.fluids[i].first;
	    while( p != NULL )
	    {
		x = (p->x/model.parms.xlength - view.xoffset) * view.xwidth;
		y = (p->y/model.parms.ylength - view.yoffset) * view.yheight;
		XFillRectangle
		(
		    display, 
		    XtWindow( widget.Main.view ), 
		    gc, 
		    x * attribs.width -1, 
		    (1.0-y) * attribs.height -1, 
		    3, 3
		);		
		p = p->next;
	    }  
	}
    }
    XSetForeground( display, gc, color.obstacle );
    for( i = 1; i <= model.imax; i++ )
	for( j = 1; j <= model.jmax; j++ )
	{
	    sx1  = i-1;
	    sx1 /= model.imax;
	    sx1 -= view.xoffset;
	    sx1 *= view.xwidth;
	    sx2  = i;
	    sx2 /= model.imax;
	    sx2 -= view.xoffset;
	    sx2 *= view.xwidth;
	    sy1  = j-1;
	    sy1 /= model.jmax;
	    sy1 -= view.yoffset;
	    sy1 *= view.yheight;
	    sy2  = j;
	    sy2 /= model.jmax;
	    sy2 -= view.yoffset;
	    sy2 *= view.yheight;
	    if( !(model.FLAG[i][j] & B_C) )
	    {
		XFillRectangle
		(
		    display, 
		    XtWindow( widget.Main.view ), 
		    gc, 
		    sx1 * attribs.width, (1.0-sy2) * attribs.height, 
		    (sx2-sx1) * attribs.width, (sy2-sy1) * attribs.height
		);
	    }
	}
    if( view.grid )
    {
	XSetForeground( display, gc, black );
	for( x = model.xmin; x <= model.xmax; x += model.parms.delx )
	{
	    sx = (x/model.parms.xlength - view.xoffset) * view.xwidth;
	    if( sx == BTW( sx, 0.0, 1.0 ) )
		XDrawLine
		(
		    display, 
		    XtWindow( widget.Main.view ), 
		    gc, 
		    sx * attribs.width, 0.0, 
		    sx * attribs.width, attribs.height
		);
	}    
	for( y = model.ymin; y <= model.ymax; y += model.parms.dely )
	{
	    sy = (y/model.parms.ylength - view.yoffset) * view.yheight;
	    if( sy == BTW( sy, 0.0, 1.0 ) )
		XDrawLine
		(
		    display, 
		    XtWindow( widget.Main.view ), 
		    gc, 
		    0.0, sy * attribs.height, 
		    attribs.width, sy * attribs.height
		);
	}
    }
    if( view.particles )
    {
	for( i = 0; i < PARTICLE_FLAVORS; i++ )
	{
	    XSetForeground( display, gc, color.particle[i] );
	    p = model.particles[i].first;
	    while( p != NULL )
	    {
		x = (p->x/model.parms.xlength - view.xoffset) * view.xwidth;
		y = (p->y/model.parms.ylength - view.yoffset) * view.yheight;
		sx = x * attribs.width - 16;
		sy = (1.0-y) * attribs.height -16;
		XCopyArea
		(
		    display, 
		    pixmaps.particle[i],
		    XtWindow( widget.Main.view ), 
		    gc, 
		    0, 0,
		    32, 32,
		    sx, sy
		);		
		p = p->next;
	    }  
	}
     
    }
}

