/* xinterface.c */

#include "representation/ctrl.h"
#include "representation/view.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <unistd.h>

/* Hauptprogramm */
int main( int argc, char **argv, char **env )
{
    ctrl_init( &argc, argv );
    view_init();
    floatator_socket = connect_to_socket( socket_name );
    
    main_loop();    /* never returns */
    
    return 0;
}

int connect_to_socket( char *socket_name )
{
    int s, success;
    struct sockaddr_un adr;

    s = socket( AF_UNIX, SOCK_STREAM, 0 );
    if( s == -1 )
    {
	fprintf( stderr, "A socket could not be created.\n" );
	exit( 1 );
    }

    strcpy( adr.sun_path, socket_name );
    adr.sun_family = AF_UNIX;

    success = connect
    ( 
        s, (struct sockaddr *)&adr, 
	strlen(adr.sun_path)+sizeof(adr.sun_family)
    );
    if( success == -1 )
    {
	fprintf
	( 
	    stderr, 
	    "The socket could not be connected to the name \"%s\".\n",  
	    socket_name
	);
	exit( 1 );
    }

    return s;   
}

void cleanup()
{
    ctrl_cleanup();
    view_cleanup();
    
    exit(0);
}

